<form *ngIf="form" [formGroup]="form">
  <ng-template ngFor let-data [ngForOf]="itemDesc.toDisplay">
    <div class="form-floating mb-3">
      <input [name]="data.property" [formControlName]="data.property" [type]="data.type?data.type:'text'"
        class="form-control" [ngClass]="{'is-invalid':form.get(data.property)?.errors && form.get(data.property)?.touched,
        'is-valid':!form.get(data.property)?.errors && form.get(data.property)?.touched}" [id]="data.property"
        [attr.aria-describedby]="'validation-'+data.property" [min]="data.min" [max]="data.max" [step]="data.step"
        >
      <label [for]="data.property" class="form-label">{{data.label}}{{itemDesc[data.addUnit]?'
        ( '+(data.addUnit=='costUnit'?'€ ':'')+itemDesc[data.addUnit]+' )':''}}
        <span *ngIf="data.required" class="text-danger"> *</span></label>
      <ng-container *ngIf="data.required">
        <div *ngIf="form.get(data.property)?.errors?.['required']" [id]="'validation-'+data.property"
          class="invalid-feedback">
          Ce champ est requis
        </div>
      </ng-container>
      <ng-container *ngIf="data['min'] != undefined">
        <div *ngIf="form.get(data.property)?.errors?.['min']" [id]="'validation-'+data.property"
          class="invalid-feedback">
          La valeur doit être supérieur ou égale {{data['min']}}
        </div>
      </ng-container>
      <ng-container *ngIf="data['max'] != undefined">
        <div *ngIf="form.get(data.property)?.errors?.['max']" [id]="'validation-'+data.property"
          class="invalid-feedback">
          La valeur doit être inférieur ou égale {{data['max']}}
        </div>
      </ng-container>
      <ng-container *ngIf="data['noDecimal']">
        <div *ngIf="form.get(data.property)?.errors?.['noDecimal']" [id]="'validation-'+data.property"
          class="invalid-feedback">
          Ne doit pas contenir de décimale
        </div>
      </ng-container>
      <ng-container *ngIf="data['date'] == 'pastOrPresent'">
        <div *ngIf="form.get(data.property)?.errors?.['pastOrPresent']" [id]="'validation-'+data.property"
          class="invalid-feedback">
          Ne doit pas être dans le futur
        </div>
      </ng-container>
    </div>
  </ng-template>
  <div class="form-floating mb-3">
    <textarea name="comment" formControlName="comment" class="form-control"
      [ngClass]="{'is-invalid':comment?.errors && comment?.touched,'is-valid':!comment?.errors && comment?.touched}"
      id="comment"></textarea>
    <label for="comment" class="form-label">Commentaire</label>
  </div>
</form>
<p class="text-muted my-0"><span class="text-danger">*</span> champs obligatoires</p>